//
// Copyright (c) 2009 Froduald Kabanza and the Université de Sherbrooke.
// Use of this software is permitted for non-commercial research purposes, and
// it may be copied or applied only for that use. All copies must include this
// copyright message.
// 
// This is a research prototype that has not gone through intensive tests and
// is delivered as is. It may still contain bugs. Froduald Kabanza and the
// Université de Sherbrooke disclaim any responsibility for damage that may be
// caused by using it.
//
// Please note that this file was inspired in part by the PDDL4J library:
// http://www.math-info.univ-paris5.fr/~pellier/software/software.php 
//
// Implementation: Daniel Castonguay
// Project Manager: Froduald Kabanza
//

#include "stdafx.h"
#include "AtMostOnceExp.h"

using namespace planning;

void AtMostOnceExp::_output(std::ostream& out) const
{
  out << "(at-most-once " << *m_exp << ")";
}

const IExp* AtMostOnceExp::_internalApply(const Bindings* bindings) const
{
  return new AtMostOnceExp(m_exp->apply(bindings));
}

int AtMostOnceExp::_internalCompareTo(const IExp& other) const
{
  const AtMostOnceExp& exp = dynamic_cast<const AtMostOnceExp&>(other);

  COMPARE(m_exp, exp.m_exp);

  return 0;
}
